import { MockIdentity } from "../auth";
import { MockDatabaseContent } from "../database";
import { firebase } from "../firebase";
import { MockFieldPath, MockFieldValue, MockFirestoreContent } from "../firestore";
export interface MockAppOptions {
    database?: {
        content: MockDatabaseContent;
    };
    deleter: () => Promise<any>;
    firestore?: {
        content: MockFirestoreContent;
        fieldPath: MockFieldPath;
        fieldValue: MockFieldValue;
    };
    identities: MockIdentity[];
    initializeOptions: Object;
    name: string;
}
export declare class MockApp implements firebase.app.App {
    private auth_;
    private databaseEmitters_;
    private database_;
    private deleter_;
    private firestoreEmitters_;
    private firestore_;
    private initializeOptions_;
    private messaging_;
    private name_;
    constructor(options: MockAppOptions);
    readonly name: string;
    readonly options: Object;
    auth(): firebase.auth.Auth;
    database(): firebase.database.Database;
    delete(): Promise<any>;
    firestore(): firebase.firestore.Firestore;
    messaging(): firebase.messaging.Messaging;
    storage(url?: string): firebase.storage.Storage;
    private databaseRootListener_(eventType, {content, previousContent});
    private firestoreRootListener_(eventType, {content, previousContent});
}
