import { firebase } from "../firebase";
import { MockEmitters } from "../mock-types";
import { MockFieldPath, MockFieldValue, MockFirestoreContent, MockFirestoreQuery } from "./mock-firestore-types";
export interface MockCollectionRefOptions {
    app: firebase.app.App;
    emitters: MockEmitters;
    fieldPath: MockFieldPath;
    fieldValue: MockFieldValue;
    firestore: firebase.firestore.Firestore;
    path: string;
    query?: MockFirestoreQuery;
    store: {
        content: MockFirestoreContent;
    };
}
export declare class MockCollectionRef implements firebase.firestore.CollectionReference {
    readonly jsonPath_: string;
    readonly query_: MockFirestoreQuery;
    private app_;
    private emitters_;
    private fieldPath_;
    private fieldValue_;
    private firestore_;
    private id_;
    private parentPath_;
    private path_;
    private refEmitter_;
    private rootEmitter_;
    private sharedEmitter_;
    private store_;
    constructor(options: MockCollectionRefOptions);
    readonly firestore: firebase.firestore.Firestore;
    readonly id: string;
    readonly parent: firebase.firestore.DocumentReference | null;
    readonly path: string;
    readonly queried_: boolean;
    add(data: firebase.firestore.DocumentData): Promise<firebase.firestore.DocumentReference>;
    doc(documentPath?: string): firebase.firestore.DocumentReference;
    endAt(snapshot: firebase.firestore.DocumentSnapshot): firebase.firestore.Query;
    endAt(...fieldValues: any[]): firebase.firestore.Query;
    endBefore(snapshot: firebase.firestore.DocumentSnapshot): firebase.firestore.Query;
    endBefore(...fieldValues: any[]): firebase.firestore.Query;
    get(): Promise<firebase.firestore.QuerySnapshot>;
    isEqual(other: firebase.firestore.Query): boolean;
    limit(limit: number): firebase.firestore.Query;
    onSnapshot(observer: {
        next?: (snapshot: firebase.firestore.QuerySnapshot) => void;
        error?: (error: Error) => void;
        complete?: () => void;
    }): () => void;
    onSnapshot(options: firebase.firestore.QueryListenOptions, observer: {
        next?: (snapshot: firebase.firestore.QuerySnapshot) => void;
        error?: (error: Error) => void;
        complete?: () => void;
    }): () => void;
    onSnapshot(onNext: (snapshot: firebase.firestore.QuerySnapshot) => void, onError?: (error: Error) => void, onCompletion?: () => void): () => void;
    onSnapshot(options: firebase.firestore.QueryListenOptions, onNext: (snapshot: firebase.firestore.QuerySnapshot) => void, onError?: (error: Error) => void, onCompletion?: () => void): () => void;
    orderBy(fieldPath: string | firebase.firestore.FieldPath, directionStr?: firebase.firestore.OrderByDirection): firebase.firestore.Query;
    startAfter(snapshot: firebase.firestore.DocumentSnapshot): firebase.firestore.Query;
    startAfter(...fieldValues: any[]): firebase.firestore.Query;
    startAt(snapshot: firebase.firestore.DocumentSnapshot): firebase.firestore.Query;
    startAt(...fieldValues: any[]): firebase.firestore.Query;
    where(fieldPath: string | firebase.firestore.FieldPath, opStr: firebase.firestore.WhereFilterOp, value: any): firebase.firestore.Query;
    private sharedListener_(eventType, {content, previousContent});
}
