import { firebase } from "../firebase";
import { MockEmitters } from "../mock-types";
import { MockFieldPath, MockFieldValue, MockFirestoreContent } from "./mock-firestore-types";
export interface MockDocumentRefOptions {
    app: firebase.app.App;
    emitters: MockEmitters;
    fieldPath: MockFieldPath;
    fieldValue: MockFieldValue;
    firestore: firebase.firestore.Firestore;
    path: string;
    store: {
        content: MockFirestoreContent;
    };
}
export declare class MockDocumentRef implements firebase.firestore.DocumentReference {
    readonly jsonPath_: string;
    private app_;
    private emitters_;
    private fieldPath_;
    private fieldValue_;
    private firestore_;
    private id_;
    private parentPath_;
    private path_;
    private refEmitter_;
    private rootEmitter_;
    private sharedEmitter_;
    private store_;
    constructor(options: MockDocumentRefOptions);
    readonly firestore: firebase.firestore.Firestore;
    readonly id: string;
    readonly parent: firebase.firestore.CollectionReference;
    readonly path: string;
    collection(collectionPath: string): firebase.firestore.CollectionReference;
    delete(): Promise<void>;
    get(): Promise<firebase.firestore.DocumentSnapshot>;
    isEqual(other: firebase.firestore.DocumentReference): boolean;
    onSnapshot(observer: {
        next?: (snapshot: firebase.firestore.DocumentSnapshot) => void;
        error?: (error: firebase.firestore.FirestoreError) => void;
        complete?: () => void;
    }): () => void;
    onSnapshot(options: firebase.firestore.DocumentListenOptions, observer: {
        next?: (snapshot: firebase.firestore.DocumentSnapshot) => void;
        error?: (error: Error) => void;
        complete?: () => void;
    }): () => void;
    onSnapshot(onNext: (snapshot: firebase.firestore.DocumentSnapshot) => void, onError?: (error: Error) => void, onCompletion?: () => void): () => void;
    onSnapshot(options: firebase.firestore.DocumentListenOptions, onNext: (snapshot: firebase.firestore.DocumentSnapshot) => void, onError?: (error: Error) => void, onCompletion?: () => void): () => void;
    set(data: firebase.firestore.DocumentData, options?: firebase.firestore.SetOptions): Promise<void>;
    update(data: firebase.firestore.UpdateData): Promise<void>;
    update(field: string | firebase.firestore.FieldPath, value: any, ...moreFieldsAndValues: any[]): Promise<void>;
    private sharedListener_(eventType, {content});
}
