import { firebase } from "../firebase";
export declare type MockDocumentPrimitive = boolean | number | string;
export declare type MockDocumentComposite = {
    [key: string]: MockDocumentPrimitive | MockDocumentComposite;
};
export declare type MockDocumentValue = MockDocumentPrimitive | MockDocumentComposite;
export declare type MockCollection = {
    [id: string]: MockDocument;
};
export declare type MockDocument = {
    collections: {
        [id: string]: MockCollection;
    };
    data: MockDocumentComposite;
};
export declare type MockDocumentPair = {
    doc: MockDocument;
    id: string;
};
export declare type MockFieldPath = {
    [key: string]: firebase.firestore.FieldPath;
};
export declare type MockFieldValue = {
    [key: string]: firebase.firestore.FieldValue;
};
export interface MockFirestoreQuery {
    endAt?: any[];
    endBefore?: any[];
    limit?: number;
    orderByDirection?: firebase.firestore.OrderByDirection;
    orderByField?: string;
    startAfter?: any[];
    startAt?: any[];
    where: {
        field?: string;
        operator?: firebase.firestore.WhereFilterOp;
        value?: any;
    }[];
}
export declare type MockFirestoreContent = {
    [id: string]: MockCollection;
} | null;
