import { firebase } from "../firebase";
import { MockEmitters } from "../mock-types";
import { MockFieldPath, MockFieldValue, MockFirestoreContent } from "./mock-firestore-types";
export interface MockFirestoreOptions {
    app: any;
    firestore: {
        content: MockFirestoreContent;
        fieldPath: MockFieldPath;
        fieldValue: MockFieldValue;
    };
    emitters: MockEmitters;
}
export declare class MockFirestore implements firebase.firestore.Firestore {
    private app_;
    private emitters_;
    private fieldPath_;
    private fieldValue_;
    private store_;
    constructor(options: MockFirestoreOptions);
    readonly app: firebase.app.App;
    readonly INTERNAL: {
        delete: () => Promise<void>;
    };
    batch(): firebase.firestore.WriteBatch;
    collection(collectionPath: string): firebase.firestore.CollectionReference;
    doc(documentPath: string): firebase.firestore.DocumentReference;
    enablePersistence(): Promise<void>;
    runTransaction<T>(updateFunction: (transaction: firebase.firestore.Transaction) => Promise<T>): Promise<T>;
    settings(settings: firebase.firestore.Settings): void;
}
