"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mock_error_1 = require("../mock-error");
var mock_collection_ref_1 = require("./mock-collection-ref");
var mock_document_ref_1 = require("./mock-document-ref");
var MockFirestore = (function () {
    function MockFirestore(options) {
        this.app_ = options.app;
        this.emitters_ = options.emitters;
        this.fieldPath_ = options.firestore.fieldPath;
        this.fieldValue_ = options.firestore.fieldValue;
        this.store_ = options.firestore;
        this.store_.content = this.store_.content || {};
    }
    Object.defineProperty(MockFirestore.prototype, "app", {
        get: function () {
            return this.app_;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MockFirestore.prototype, "INTERNAL", {
        get: function () {
            return { delete: function () { return Promise.resolve(); } };
        },
        enumerable: true,
        configurable: true
    });
    MockFirestore.prototype.batch = function () {
        throw mock_error_1.unsupported_();
    };
    MockFirestore.prototype.collection = function (collectionPath) {
        return new mock_collection_ref_1.MockCollectionRef({
            app: this.app_,
            emitters: this.emitters_,
            fieldPath: this.fieldPath_,
            fieldValue: this.fieldValue_,
            firestore: this,
            path: collectionPath,
            store: this.store_
        });
    };
    MockFirestore.prototype.doc = function (documentPath) {
        return new mock_document_ref_1.MockDocumentRef({
            app: this.app_,
            emitters: this.emitters_,
            fieldPath: this.fieldPath_,
            fieldValue: this.fieldValue_,
            firestore: this,
            path: documentPath,
            store: this.store_
        });
    };
    MockFirestore.prototype.enablePersistence = function () {
        throw mock_error_1.unsupported_();
    };
    MockFirestore.prototype.runTransaction = function (updateFunction) {
        throw mock_error_1.unsupported_();
    };
    MockFirestore.prototype.settings = function (settings) {
    };
    return MockFirestore;
}());
exports.MockFirestore = MockFirestore;
