import { MockIdentity } from "./auth";
import { MockDatabaseContent } from "./database";
import { MockFirestoreContent } from "./firestore";
export interface MockOptions {
    apps?: {
        [key: string]: {
            database?: {
                content: MockDatabaseContent;
            };
            firestore?: {
                content: MockFirestoreContent;
                fieldPath?: any;
                fieldValue?: any;
            };
            identities?: MockIdentity[];
        };
    };
    database?: {
        content: MockDatabaseContent;
    };
    firestore?: {
        content: MockFirestoreContent;
        fieldPath?: any;
        fieldValue?: any;
    };
    identities?: MockIdentity[];
}
export declare class MockUntyped {
    private apps_;
    private options_;
    constructor(options?: MockOptions);
    readonly apps: any[];
    readonly SDK_VERSION: string;
    app(name?: string): any;
    auth(app?: any): any;
    database(app?: any): any;
    firestore(app?: any): any;
    initializeApp(options: any, name?: string): any;
    messaging(app?: any): any;
    storage(app?: any): any;
}
