"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var firebase = require("firebase");
var mock_untyped_1 = require("./mock-untyped");
var Mock = (function () {
    function Mock(options) {
        var firestore = (options && options.firestore) ? tslib_1.__assign({ fieldPath: {
                documentId: firebase.firestore.FieldPath.documentId()
            }, fieldValue: {
                delete: firebase.firestore.FieldValue.delete(),
                serverTimestamp: firebase.firestore.FieldValue.serverTimestamp()
            } }, options.firestore) : {};
        this.untyped_ = new mock_untyped_1.MockUntyped(tslib_1.__assign({}, options, firestore));
    }
    Object.defineProperty(Mock.prototype, "apps", {
        get: function () {
            return this.untyped_.apps;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Mock.prototype, "SDK_VERSION", {
        get: function () {
            return this.untyped_.SDK_VERSION;
        },
        enumerable: true,
        configurable: true
    });
    Mock.prototype.app = function (name) {
        return name ? this.untyped_.app() : this.untyped_.app(name);
    };
    Mock.prototype.auth = function (app) {
        return name ? this.untyped_.auth() : this.untyped_.auth(app);
    };
    Mock.prototype.database = function (app) {
        return name ? this.untyped_.database() : this.untyped_.database(app);
    };
    Mock.prototype.firestore = function (app) {
        return name ? this.untyped_.firestore() : this.untyped_.firestore(app);
    };
    Mock.prototype.initializeApp = function (options, name) {
        return name ? this.untyped_.initializeApp(options, name) : this.untyped_.initializeApp(options);
    };
    Mock.prototype.messaging = function (app) {
        return name ? this.untyped_.messaging() : this.untyped_.messaging(app);
    };
    Mock.prototype.storage = function (app) {
        return name ? this.untyped_.storage() : this.untyped_.storage(app);
    };
    return Mock;
}());
exports.Mock = Mock;
